SystemOrganization addCategory: #'Eg-TestExperiments-ConvertedTests'!
SystemOrganization addCategory: #'Eg-TestExperiments'!
SystemOrganization addCategory: #'Eg-TestExperiments-ConvertedTests-Tests-Collections-Streams'!
SystemOrganization addCategory: #'Eg-TestExperiments-ConvertedTests-Tests-VM'!
SystemOrganization addCategory: #'Eg-TestExperiments-ConvertedTests-Tests-Bugs'!
SystemOrganization addCategory: #'Eg-TestExperiments-ConvertedTests-Tests-Kernel-Methods'!

RefactoringBrowser subclass: #ExtractToResultRefactoringBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments'!

!ExtractToResultRefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'mga 1/25/2004 17:04'!
messageMenuFor: aNode 
	"add: stuff action: bar"
	| aMenu |
	aMenu:= super messageMenuFor: aNode.
	^aMenu
		add: 'extract to result...' action: #extractToResult;
		yourself
	! !

!ExtractToResultRefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'mga 1/25/2004 17:15'!
extractToResult
	|  node |
	self updateRequest ifFalse: [^self].
	node := self findNode.
	(node isNil or: [node isValue not]) 
		ifTrue: [^self warn: 'Could not find the node'].
	self performRefactoring: (ExtractToResultRefactoring 
				extract: (self convertToSourceInterval: node sourceInterval)
				to: 'aResult'
				from: self selector
				in: self selectedClassOrMetaClass)! !

!RBMethodNode methodsFor: '*Eg-TestExperiments' stamp: 'mga 1/4/2004 22:34'!
methodUnderTestAssignmentContainingNode
	| lastStatement aReturnNodeVariable |
	lastStatement:= self body statements last.
	aReturnNodeVariable:=lastStatement value.
	^(self body statements select: [:each | each assigns: aReturnNodeVariable name]) last! !

!RBMethodNode methodsFor: '*Eg-TestExperiments' stamp: 'mga 1/4/2004 19:33'!
methodUnderTestAssignment
	| lastStatement aReturnNodeVariable lastAssignmentContainingNode |
	lastStatement:= self body statements last.
	aReturnNodeVariable:=lastStatement value.
	lastAssignmentContainingNode := (self body statements select: [:each | each assigns: aReturnNodeVariable name]) last .
	^lastAssignmentContainingNode allChildren detect: [:each | each isAssignment and: [each assigns: aReturnNodeVariable name]] ifNone: [lastAssignmentContainingNode]! !

!TestCase methodsFor: '*Eg-TestExperiments' stamp: 'mga 12/18/2003 16:07'!
classMethodUnderTestBySimpleConvention
	
	|aClass aSelWithoutTest |
	aClass:= self class accordingClassByConvention.
	self assert: aClass notNil.
	aSelWithoutTest:= (testSelector asString copyFrom: 5 to: testSelector size) asLowercase.
	^aClass class >> (aClass class selectors detect: [:each | (each asString copyWithout: $:) asLowercase = aSelWithoutTest] ifNone: [^nil])
	! !

!TestCase methodsFor: '*Eg-TestExperiments' stamp: 'mga 12/31/2003 11:42'!
classUnderTest
	^self compiledMethodUnderTest methodClass! !

!TestCase class methodsFor: '*Eg-TestExperiments' stamp: 'mga 12/18/2003 16:05'!
allKeywordTestsFollowingSimpleConvention
	
	|someTests|
	someTests:=OrderedCollection new.
	self subclassesBelongingToRealclassesByConvention do: [:each |
			someTests addAll: each keywordTestsFollowingSimpleConvention].
	^someTests! !

!TestCase class methodsFor: '*Eg-TestExperiments' stamp: 'mga 12/23/2003 13:11'!
allTestsFollowingSomeConvention
	^(self allTestsFollowingSimpleConvention  
		addAll: self allTestsFollowingBrowseUnitConvention;
		yourself) asOrderedCollection! !

TestCase subclass: #BitmapStreamTests
	instanceVariableNames: 'random array stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests-Tests-Bugs'!

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:56'!
testShortPointArrayWithSmartRefStream
	| aResult |
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	aResult:= self validateSmartRefStream.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 16:00'!
randomShortPoint
	^(((random next * 65536) @ (random next * 65536)) - (32768 @ 32768)) truncated! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:57'!
testShortRunArrayWithRefStream
	| aResult |
	array _ ShortRunArray newFrom: ((1 to: 10) collect: [ :i | self randomShortInt ]).
	aResult:=self validateRefStream.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:56'!
testShortPointArrayWithRefStreamOnDisk
	| aResult |
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	aResult:= self validateRefStreamOnDisk.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:57'!
testShortPointArrayWithSmartRefStreamOnDisk
	| aResult |
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	aResult:=self validateSmartRefStreamOnDisk.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:56'!
testShortPointArrayWithRefStream
	| aResult |
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	aResult:= self validateRefStream.
	^aResult	! !

!BitmapStreamTests methodsFor: 'Running' stamp: 'nk 7/5/2003 15:22'!
setUp
	random _ Random new.! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:55'!
testShortIntegerArrayWithSmartRefStream
	| aResult |
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	aResult:= self validateSmartRefStream.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:58'!
testWordArrayWithSmartRefStream
	| aResult |
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	aResult:=self validateSmartRefStream.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mga 1/5/2004 22:46'!
validateSmartRefStreamOnDisk
	"array is set up with an array."
	| other filename |

	filename _ 'bitmapStreamTest.ref'.
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	stream _ FileDirectory default fileNamed: filename.
	stream fileOutClass: nil andObject: array.
	stream close.

	stream _ FileDirectory default fileNamed: filename.
	other _ stream fileInObjectAndCode.
	stream close.

	self assert: array = other.
	^other! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:57'!
testShortRunArrayWithRefStreamOnDisk
	| aResult |
	array _ ShortRunArray newFrom: ((1 to: 10) collect: [ :i | self randomShortInt ]).
	aResult:=self validateRefStreamOnDisk.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 16:33'!
randomShortInt
	^((random next * 65536) - 32768) truncated! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:57'!
testShortRunArrayWithImageSegment
	| aResult |
	array _ ShortRunArray newFrom: ((1 to: 10) collect: [ :i | self randomShortInt ]).
	aResult:=self validateImageSegment .
	^aResult
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mga 1/5/2004 22:46'!
validateRefStream
	"array is set up with an array."
	| other rwstream |
	rwstream _ RWBinaryOrTextStream on: (ByteArray new: array basicSize * 6).

	stream _ ReferenceStream on: rwstream.
	stream nextPut: array; close.

	rwstream position: 0.
	stream _ ReferenceStream on: rwstream.
	other _ stream next.
	stream close.

	self assert: array = other.
	^other! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:55'!
testShortIntegerArrayWithSmartRefStreamOnDisk
	| aResult |
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	aResult:= self validateSmartRefStreamOnDisk.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 18:26'!
randomWord
	"Answer a random 32-bit integer"
	| w |
	random seed: (w _ random nextValue).
	^w truncated! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:58'!
testWordArrayWithRefStreamOnDisk
	| aResult |
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	aResult:=self validateRefStreamOnDisk.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:58'!
testWordArrayWithSmartRefStreamOnDisk
	| aResult |
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	aResult:= self validateSmartRefStreamOnDisk.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/5/2004 22:25'!
testShortIntegerArrayWithImageSegment
	|aResult|
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	aResult:= self validateImageSegment.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mga 1/5/2004 22:46'!
validateRefStreamOnDisk
	"array is set up with an array."
	| other filename |

	filename _ 'bitmapStreamTest.ref'.
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	stream _ ReferenceStream fileNamed: filename.
	stream nextPut: array; close.

	stream _ ReferenceStream fileNamed: filename.
	other _ stream next.
	stream close.

	self assert: array = other.
	^other! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:57'!
testShortRunArrayWithSmartRefStreamOnDisk
	| aResult |
	array _ ShortRunArray newFrom: ((1 to: 10) collect: [ :i | self randomShortInt ]).
	aResult:= self validateSmartRefStreamOnDisk.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:58'!
testWordArrayWithImageSegment
	| aResult |
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	aResult:=self validateImageSegment.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mga 1/5/2004 22:46'!
validateSmartRefStream
	"array is set up with an array."
	| other |
	stream _ RWBinaryOrTextStream on: (ByteArray new: array basicSize * 6).
	stream binary.
	stream fileOutClass: nil andObject: array.
	stream position: 0.
	stream binary.
	other _ stream fileInObjectAndCode.
	self assert: array = other.
	^other! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mga 1/6/2004 01:08'!
validateImageSegment
	"array is set up with an array."
	| other filename |
	filename _ 'bitmapStreamTest.extSeg'.

	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	(ImageSegment new copyFromRootsForExport: (Array with: array))
         writeForExport: filename.

	other _ (FileDirectory default readOnlyFileNamed: filename)
		fileInObjectAndCode.

	self assert: array = other originalRoots first.
	^other! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:57'!
testShortRunArrayWithSmartRefStream
	| aResult |
	array _ ShortRunArray newFrom: ((1 to: 10) collect: [ :i | self randomShortInt ]).
	aResult:=self validateSmartRefStream.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:56'!
testShortPointArrayWithImageSegment
	| aResult |
	array _ ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	aResult:= self validateImageSegment.
	^aResult! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:55'!
testShortIntegerArrayWithRefStreamOnDisk
	| aResult |
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	aResult:=self validateRefStreamOnDisk.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:58'!
testWordArrayWithRefStream
	| aResult |
	array _ WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	aResult:=self validateRefStream.
	^aResult
	! !

!BitmapStreamTests methodsFor: 'Tests' stamp: 'mga 1/4/2004 21:55'!
testShortIntegerArrayWithRefStream
	|aResult|
	array _ ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	aResult:= self validateRefStream.
	^aResult
	! !

TestCase subclass: #BecomeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests-Tests-VM'!

!BecomeTest methodsFor: 'Testing' stamp: 'mga 1/5/2004 22:45'!
testBecomeHash

	| a b c d ha hb aResult |

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	d := b.
	ha := a hash.
	hb := b hash.

	aResult:=a become: b.

	self 
		assert: a hash = hb;
		assert: b hash = ha;
		assert: c hash = hb;
		assert: d hash = ha.
	^aResult

! !

!BecomeTest methodsFor: 'Testing' stamp: 'mga 1/5/2004 22:45'!
testBecomeIdentityHash
	"Note. The identity hash of both objects seems to change after the become:"

	| a b c d aResult |

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	d := b.

	aResult:= a become: b.

	self 
		assert: a identityHash = c identityHash;
		assert: b identityHash = d identityHash;
		deny: a identityHash = b identityHash.
	^aResult
! !

!BecomeTest methodsFor: 'Testing' stamp: 'mga 1/5/2004 22:45'!
testBecome
	"Test the two way become. Note. we cannot use string literals for this test"
	"(self selector: #testBecome) methodReferenceUnderTest"
	| a b c d aResult|

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	d := b.

	aResult:= a become: b.

	self 
		assert: a = 'cd';
		assert: b = 'ab';
		assert: c = 'cd';
		assert: d = 'ab'.
	^aResult


! !

!BecomeTest methodsFor: 'Testing' stamp: 'mga 1/5/2004 22:45'!
testBecomeForwardIdentityHash
	"Check that
		1. the argument to becomeForward: is modified to have the receiver's identity hash.
		2. the receiver's identity hash is unchanged."

 	| a b ha aResult |

	a := 'ab' copy.
	b := 'cd' copy.
	ha := a identityHash.

	aResult:= a becomeForward: b.

	self 
		assert: a identityHash = ha;
		assert: b identityHash = ha.
	^aResult

! !

!BecomeTest methodsFor: 'Testing' stamp: 'brp 9/19/2003 17:36'!
testBecomeForwardDontCopyIdentityHash
	"Check that
		1. the argument to becomeForward: is NOT modified to have the receiver's identity hash.
		2. the receiver's identity hash is unchanged."

 	| a b hb |

	a := 'ab' copy.
	b := 'cd' copy.
	hb := b identityHash.

	a becomeForward: b copyHash: false.

	self 
		assert: a identityHash = hb;
		assert: b identityHash = hb.

! !

!BecomeTest methodsFor: 'Testing' stamp: 'mga 1/5/2004 22:45'!
testBecomeForwardHash

	| a b c hb aResult |

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	hb := b hash.

	aResult:= a becomeForward: b.

	self 
		assert: a hash = hb;
		assert: b hash = hb;
		assert: c hash = hb.
	^aResult

! !

!BecomeTest methodsFor: 'Testing' stamp: 'mga 1/5/2004 22:45'!
testBecomeForward
	"Test the forward become."
	"(self selector: #testBecomeForward) methodReferenceUnderTest"
	
	| a b c d aResult|

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	d := b.

	aResult:= a becomeForward: b.

	self 
		assert: a = 'cd';
		assert: b = 'cd';
		assert: c = 'cd';
		assert: d = 'cd'.
	^aResult

! !

!TestCase methodsFor: '*Eg-TestExperiments' stamp: 'mga 1/5/2004 12:13'!
compiledMethodUnderTest

	^self receiverUnderTest class lookupSelector: self selectorUnderTest! !

!TestCase class methodsFor: '*Eg-TestExperiments' stamp: 'mga 12/18/2003 16:01'!
keywordTestsFollowingConvention
	
	^((self testSelectors collect: [:aSel | self selector: aSel]) select: [:aCase | |aMethod|
		aMethod:= aCase methodUnderTestByConvention.
		aMethod notNil and: [aMethod selector isKeyword]])
	! !

!TestCase class methodsFor: '*Eg-TestExperiments' stamp: 'mga 12/18/2003 12:45'!
numberOfTests
	|aSize|
	aSize:= 0.
	self allSubclasses do: [:e | 
		aSize := aSize + e testSelectors size].
	^aSize! !

!TestCase class methodsFor: '*Eg-TestExperiments' stamp: 'mga 1/5/2004 00:06'!
methodReferencesUnderTest
	^self tests collect: [:each | each methodReferenceUnderTest]! !

TestCase subclass: #Base64MimeConverterTest
	instanceVariableNames: 'message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests-Tests-Collections-Streams'!

!Base64MimeConverterTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class Base64MimeConverter. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category!

!Base64MimeConverterTest methodsFor: 'initialize-release' stamp: 'mga 1/5/2004 22:45'!
testMimeDecode
	"self debug: #testMimeDecode"
	
	| decoded |

	decoded:= Base64MimeConverter mimeDecodeToChars: self testMimeEncode.
	self should: [decoded contents = message contents].
	^decoded! !

!Base64MimeConverterTest methodsFor: 'initialize-release' stamp: 'md 3/17/2003 15:34'!
tearDown
	"I am called whenever your test ends. 
I am the place where you release the ressources"! !

!Base64MimeConverterTest methodsFor: 'initialize-release' stamp: 'mga 1/5/2004 22:45'!
testMimeEncode
	"self debug: #testMimeEncode"
	
	| encoded |

	encoded _ Base64MimeConverter mimeEncode: message.
	
	self should: [encoded contents = 'SGkgVGhlcmUh'].
	^encoded! !

!Base64MimeConverterTest methodsFor: 'initialize-release' stamp: 'md 3/17/2003 15:37'!
setUp
	message _ ReadWriteStream on: (String new: 10).
	message nextPutAll: 'Hi There!!'.! !

!Base64MimeConverterTest methodsFor: 'initialize-release' stamp: 'mga 1/5/2004 22:45'!
testMimeEncodeDecode

	| encoded |

	encoded _ Base64MimeConverter mimeEncode: message.
	
	self should: [encoded contents = 'SGkgVGhlcmUh'].
     self should: [(Base64MimeConverter mimeDecodeToChars: encoded)
                      contents = message contents].
	^encoded! !

TestCase subclass: #BitmapBugz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests-Tests-Bugs'!

!BitmapBugz methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testBitmapByteAt
	| bm aResult |
	bm := Bitmap new: 1.
	1 to: 4 do:[:i|
		self should:[aResult:=bm byteAt: i put: 1000] raise: Error.
	].
	^aResult! !

TestCase subclass: #ByteArrayBugz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests-Tests-Bugs'!

!ByteArrayBugz methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testByteArrayLongAt
	| ba value aRes |
	ba := ByteArray new: 4.
	value := -1.
	self shouldnt:[aRes:=ba longAt: 1 put: value bigEndian: true] raise: Error.
	self assert: (ba longAt: 1 bigEndian: true) = value.
	self shouldnt:[ba longAt: 1 put: value bigEndian: false] raise: Error.
	self assert: (ba longAt: 1 bigEndian: false) = value.
	^aRes
! !

TestCase subclass: #AnalyzerTest
	instanceVariableNames: 'classesCreated '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests'!

!AnalyzerTest methodsFor: 'utility' stamp: 'rw 5/12/2003 11:56'!
removeClassNamedIfExists: aClassname

	Smalltalk at: aClassname ifPresent: [:cls| cls removeFromSystem].
	Smalltalk at: aClassname ifPresent: [:clss| self error: 'Error !!!!']! !

!AnalyzerTest methodsFor: 'utility' stamp: 'md 10/29/2003 23:42'!
createClass: aClassname superclass: aClass 
	| r |
	r _ aClass
		subclass: aClassname
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Tests-KCP'.
	classesCreated add: r.
	^ r! !

!AnalyzerTest methodsFor: 'running' stamp: 'ab 3/8/2003 13:54'!
setUp
	classesCreated _ OrderedCollection new! !

!AnalyzerTest methodsFor: 'running' stamp: 'sd 5/23/2003 14:51'!
tearDown

	| name |
	classesCreated
		do: [:cls | 
			name _ cls name.
			self removeClassNamedIfExists: name.
			ChangeSet current removeClassChanges: name].
	classesCreated _ nil! !

!AnalyzerTest methodsFor: 'methods' stamp: 'mga 1/5/2004 22:45'!
testMethodCallDefinedInSubclasses
	| cls1 cls2 r r1|
	cls1 _ self createClass: #MyClass1.
	cls2 _ self createClass: #MyClass2 superclass: cls1.
	"-------"
	cls1 compile: 'foo ^ self bar'.
	cls2 compile: 'bar ^ true'.
	"-------"
	self assert: cls2 new foo.
	r _ Analyzer
				methodsIn: cls1
				callingMethodsDefinedIn: (Array with: cls2).
	r1 _ r asOrderedCollection.
	self assert: r1 size = 1.
	self assert: r1 first size = 2.
	self assert: r1 first first == #foo.
	self assert: r1 first second == #bar.
	^r
! !

!AnalyzerTest methodsFor: 'dependencies' stamp: 'mga 1/5/2004 22:45'!
testExternalReferenceOf
	"(self selector: #testExternalReferenceOf) methodReferenceUnderTest"
	
	| r cls1 cls2 cls3 |
	cls1 _ self createClass: #MyClass1.
	cls2 _ self createClass: #MyClass2.
	cls3 _ self createClass: #MyClass3.
	"-------"
	cls1 compile: 'foo ^ MyClass2'.
	cls1 compile: 'bar MyClass1 show: ''blah blah'''.
	cls1 compile: 'zork OrderedCollection new'.
	cls1 compile: 'baz Morph new openInWorld'.
	"-------"
	cls2 compile: 'foo ^ Object'.
	cls2 compile: 'bar Transcript show: ''blah blah'''.
	cls2 compile: 'zork OrderedCollection new'.
	"-------"
	cls3 compile: 'foo ^ Object'.
	cls3 compile: 'bar Transcript show: ''blah blah'''.
	cls3 compile: 'zork MyClass3 new'.
	"-------"
	r _ Analyzer
				externalReferenceOf: (#(#MyClass1 #MyClass2 #MyClass3 )
						collect: [:clsName | Smalltalk at: clsName]).
	self assert: r size = 4.
	self
		assert: (r includesAllOf: #(#Object #Transcript #OrderedCollection #Morph )).
	^r! !

!AnalyzerTest methodsFor: 'methods' stamp: 'mga 1/5/2004 22:45'!
testMethodCallDefinedInSubclasses2
	| cls1 cls2 r r1 cls3 cls4 |
	cls1 _ self createClass: #MyClass1.
	cls2 _ self createClass: #MyClass2 superclass: cls1.
	cls3 _ self createClass: #MyClass3.
	cls4 _ self createClass: #MyClass4 superclass: cls3.
	"-------"
	cls1 compile: 'foo ^ self f1; f2'.
	cls1 compile: 'bar ^ self f3; foo'.
	cls1 compile: 'zork ^ self bar; blah'.
	cls2 compile: 'f1 ^ true'.
	cls2 compile: 'f2 ^ true'.
	cls3 compile: 'f3 ^ true'.
	cls3 compile: 'foo ^ true'.
	cls4 compile: 'f3 ^ true'.
	cls4 compile: 'f4 ^ true'.
	cls4 compile: 'bleubleu ^ true'.
	cls4 compile: 'bouba ^ true'.
	"-------"
	r _ Analyzer
				methodsIn: cls1
				callingMethodsDefinedIn: (Array
						with: cls2
						with: cls3
						with: cls4).
	r1 _ r asOrderedCollection.
	self assert: r1 size = 3.
	self
		assert: (r1 includesAllOf: #(#(#foo #f1) #(#foo #f2) #(#bar #f3) )).
	^r
! !

!AnalyzerTest methodsFor: 'dependencies' stamp: 'mga 1/5/2004 22:45'!
testDependenciesForClass
	"(self selector: #testDependenciesForClass) methodReferenceUnderTest"
	| cls r |
	cls _ self createClass: #MyClass.
	"-------"
	cls compile: 'foo ^ Object'.
	cls compile: 'bar Transcript show: ''blah blah'''.
	cls compile: 'zork OrderedCollection new'.
	"-------"
	r _ Analyzer dependenciesForClass: cls.
	self assert: r size = 3.
	self
		assert: (r includesAllOf: #(#Object #Transcript #OrderedCollection )).
	^r
! !

!AnalyzerTest methodsFor: 'methods' stamp: 'mga 1/5/2004 22:45'!
testMethodsCalledForClass
	| cls r |
	cls _ self createClass: #MyClass.
	"-------"
	cls compile: 'foo ^ Object'.
	cls compile: 'bar Transcript show: ''blah blah'''.
	cls compile: 'zork OrderedCollection new'.
	cls compile: 'foobar Object new asMorph; beep'.
	"-------"
	r _ Analyzer methodsCalledForClass: cls.
	self assert: r size = 3.
	self
		assert: (r includesAllOf: #(#beep #show: #asMorph )).
	^r
! !

!AnalyzerTest methodsFor: 'methods' stamp: 'mga 1/5/2004 22:45'!
testMethodsCalledAndCalleeForClass
	| cls r |
	cls _ self createClass: #MyClass.
	"-------"
	cls compile: 'foo ^ Object'.
	cls compile: 'bar Transcript show: ''blah blah'''.
	cls compile: 'zork OrderedCollection new'.
	cls compile: 'foobar Object new asMorph; beep'.
	"-------"
	r _ Analyzer methodsCalledAndCalleeForClass: cls.
	self assert: r size = 3.
	self
		assert: (r includesAllOf: #(#(#bar #show:) #(#foobar #asMorph) #(#foobar #asMorph) )).
	^r
! !

!AnalyzerTest methodsFor: 'utility' stamp: 'ab 3/8/2003 13:55'!
createClass: aClassname
	^ self createClass: aClassname superclass: Object 
! !

!AnalyzerTest methodsFor: 'utility' stamp: 'md 10/29/2003 23:41'!
removeClassIfExists: aClassname 
	Smalltalk
		at: aClassname
		ifPresent: [:cls | cls removeFromSystem] ! !

TestCase subclass: #BitBltClipBugs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests-Tests-Bugs'!

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testDrawingWayOutside6
	| f1 bb f2 aResult |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	bb sourceOrigin: SmallInteger maxVal squared asPoint.
	self shouldnt:[aResult:= bb copyBits] raise: Error.
	^aResult
! !

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testDrawingWayOutside2
	| f1 bb f2 aResult |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: 0@0.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	self shouldnt:[aResult:=bb copyBits] raise: Error.
	^aResult! !

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testDrawingWayOutside4
	| f1 bb f2 aResult|
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: 100; height: 100.
	bb sourceOrigin: SmallInteger maxVal squared asPoint.
	self shouldnt:[aResult:=bb copyBits] raise: Error.
	^aResult
! !

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testDrawingWayOutside5
	"(self selector: #testDrawingWayOutside5) methodReferenceUnderTest"
	| f1 bb f2 aResult |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: 0@0.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	bb sourceOrigin: SmallInteger maxVal squared asPoint.
	self shouldnt:[aResult:=bb copyBits] raise: Error.
	^aResult! !

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testFillingWayOutside3
	| f1 bb aResult |
	f1 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb fillColor: Color black.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	self shouldnt:[aResult:= bb copyBits] raise: Error.
	^aResult
! !

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testFillingWayOutside2
	| f1 bb aResult |
	f1 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb fillColor: Color black.
	bb destOrigin: 0@0.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	self shouldnt:[aResult:=bb copyBits] raise: Error.
	^aResult! !

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testFillingWayOutside
	| f1 bb aResult |
	f1 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb fillColor: Color black.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: 100; height: 100.
	self shouldnt:[aResult:= bb copyBits] raise: Error.
	^aResult! !

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testDrawingWayOutside3
	| f1 bb f2 aResult |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	self shouldnt:[aResult:= bb copyBits] raise: Error.
	^aResult
! !

!BitBltClipBugs methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
testDrawingWayOutside
	| f1 bb f2 aResult|
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: 100; height: 100.
	self shouldnt:[aResult:=bb copyBits] raise: Error.
	^aResult
! !

!TestCase methodsFor: '*Eg-TestExperiments' stamp: 'mga 1/5/2004 22:42'!
receiverUnderTest
	|aTree lastAssignment aResult anInstance aChange lastStatement previousChangeSet testsChangeSet lastAssignmentContainingNode shouldRaiseNode | 
 
	aTree:= (self class methodDictionary at: self receiverContainingTestSelector) parseTree.
	self assert: (aTree body lastIsReturn).
	lastAssignment := aTree methodUnderTestAssignment.
	lastAssignmentContainingNode:= aTree methodUnderTestAssignmentContainingNode.
	lastAssignment value: lastAssignment value receiver.
	lastStatement:= aTree body statements last.
	shouldRaiseNode:= ((OrderedCollection with: lastAssignmentContainingNode) addAll:  lastAssignmentContainingNode allChildren;yourself) detect: [:e | e isMessage and: [e selector = #should:raise: and: [e receiver value name = 'self']]] ifNone: [nil].
	shouldRaiseNode notNil ifTrue: [
		|anIndex|
		anIndex:= shouldRaiseNode parent statements indexOf: shouldRaiseNode.
		shouldRaiseNode parent statements: (shouldRaiseNode parent statements copyReplaceFrom: anIndex to: anIndex with: (Array with: lastAssignment) )].
	aTree body statements: (aTree body statements copyUpTo: (lastAssignmentContainingNode:= aTree methodUnderTestAssignmentContainingNode)).
	aTree body statements add: lastAssignmentContainingNode;add: lastStatement.
	previousChangeSet := ChangeSet current.
	testsChangeSet := ChangeSet new.
	ChangeSet newChanges: testsChangeSet.

	aChange := (AddMethodChange 
		compile: aTree formattedCode 
		in: self class 
		classified: #testing) execute.
	[anInstance:= self class new.
	aResult:= [anInstance setUp;perform: testSelector] ensure: [anInstance tearDown]] ensure: [aChange execute].
	ChangeSet newChanges: previousChangeSet.
	ChangeSorter removeChangeSet: testsChangeSet.
	previousChangeSet := nil.
	testsChangeSet := nil.
	^aResult! !

TestCase subclass: #BCCMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests'!

!BCCMTest commentStamp: '<historical>' prior: 0!
This class contains some tests regarding the classes 
	Behavior
		ClassDescription
			Class
			Metaclass
---
	!

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test02metaclassNumberOfInstances
	"(BCCMTest selector: #test02metaclassNumberOfInstances) selectorUnderTest"


	|aResult|
	aResult:= Dictionary class allInstances.
	self assert: aResult size  = 1.
	self assert: OrderedCollection class allInstances size  = 1.
	^aResult! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test09ObjectAllSubclasses
	"(self selector: #test09ObjectAllSubclasses) selectorUnderTest"
	
	| n2 aResult|
	aResult:= Object allSubclasses.
	n2 _ aResult size.
	self assert: n2 = (Object allSubclasses
			select: [:cls | cls class class == Metaclass
					or: [cls class == Metaclass]]) size.
	^aResult! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test07bmetaclassPointOfCircularity

	
	|aResult|
	self assert: Metaclass class instanceCount = 1.
	aResult:= Metaclass class someInstance.
	self assert: aResult == Metaclass.
	^aResult


	
	
	



	
	

	! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test08BCCMhierarchy

	
	|aResult|
	aResult:= Class superclass.
	self assert: (aResult  == ClassDescription).
	self assert: Metaclass superclass == ClassDescription.

	self assert: ClassDescription superclass  == Behavior.
	self assert: Behavior superclass  = Object.


	self assert: Class class class ==  Metaclass.
	self assert: Metaclass class class  == Metaclass.
	self assert: ClassDescription class class == Metaclass.
	self assert: Behavior class class == Metaclass.
	^aResult




	
	
	



	
	

	! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test03superclass

	"(self selector: #test03superclass) selectorUnderTest"
	| s aResult|
	aResult:=  Dictionary superclass.
	self assert: aResult == Set.
	self assert: OrderedCollection superclass == SequenceableCollection.

	s _ OrderedCollection new.
	s add: SequenceableCollection.
	s add: Collection.
	s add: Object.
	s add: ProtoObject.

	self assert: OrderedCollection allSuperclasses = s.
	^aResult
	
	! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test05metaclassSuperclassHierarchy


	| s aResult|
	
	aResult:= SequenceableCollection class instanceCount.
	self assert: aResult  = 1.
	self assert: Collection class instanceCount  = 1.
	self assert: Object class instanceCount  = 1.
	self assert: ProtoObject class instanceCount  = 1.
	
	s _ OrderedCollection new.
	s add: SequenceableCollection class.
	s add: Collection class.
	s add: Object class.
	s add: ProtoObject class.

	s add: Class.
	s add: ClassDescription.
	s add: Behavior.
	s add: Object.
	s add: ProtoObject.

	self assert: OrderedCollection class allSuperclasses  = s.
	^aResult



	
	

	! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test07metaclass

	
	|aResult|
	aResult:= OrderedCollection class class.
	self assert: aResult == Metaclass.
	self assert: OrderedCollection class class = Metaclass.

	self assert: Dictionary class class == Metaclass.
	self assert: Dictionary class class = Metaclass.


	self assert: Object class class == Metaclass.
	self assert: Object class class = Metaclass.
	^aResult


	
	
	



	
	

	! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test01metaclassName
	"(BCCMTest selector: #test01metaclassName) selectorUnderTest"
	|aResult|	
	aResult := Dictionary class name.
	self assert: aResult = 'Dictionary class'.
	self assert: OrderedCollection class name = 'OrderedCollection class'.
	^aResult
	! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test04metaclassSuperclass

	"(self selector: #test04metaclassSuperclass) selectorUnderTest"
	
	| aResult |
	aResult:= Dictionary class superclass.
	self assert: (aResult == Set class).
	self assert: OrderedCollection class superclass == SequenceableCollection class.
	^aResult

	! !

!BCCMTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
test06ClassDescriptionAllSubInstances


	
	|aResult  cdNo clsNo metaclsNo |
	aResult := ClassDescription allSubInstances.
	cdNo _  aResult size.
	clsNo _ Class allSubInstances size .
	metaclsNo _ Metaclass allSubInstances size.

	self assert: cdNo = (clsNo + metaclsNo).
	^aResult

	
	
	



	
	

	! !

TestCase subclass: #TestCaseTest
	instanceVariableNames: 'previousChangeSet testsChangeSet '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments'!

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/4/2004 21:12'!
testCompiledMethodUnderTest
	|aResult|
	aResult:=(TestCaseTest selector: #testSelectorUnderTest) compiledMethodUnderTest.
	self assert: (aResult = (TestCase lookupSelector: #selectorUnderTest)).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/6/2004 01:08'!
testNewChar
	| aRes |
	self should: [aRes:=Character new] raise: Error.
	^aRes! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 12/29/2003 16:17'!
testAdd
	|anOc aResult|
	anOc:=OrderedCollection new.
	aResult:= anOc add: 2.
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/4/2004 19:38'!
testReceiverUnderTest
	|aResult|
	aResult:=(TestCaseTest selector: #testSum) receiverUnderTest.
	self assert: (aResult class = Interval).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/6/2004 01:08'!
testBitmapByteAt
	| bm aResult |
	bm := Bitmap new: 1.
	1 to: 4 do:[:i|
		self should:[aResult:=bm byteAt: i put: 1000] raise: Error.
	].
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 12/31/2003 14:24'!
testClassUnderTest
	|aResult|
	aResult:=(TestCaseTest selector: #testSum) classUnderTest.
	self assert: (aResult = Collection).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 12/29/2003 19:40'!
testSelectorUnderTest3
	|aResult|
	aResult:=(BitmapStreamTests selector: #testShortIntegerArrayWithImageSegment) selectorUnderTest.
	self assert: (aResult = #fileInObjectAndCode).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:31'!
testClassUnderTest1
	|aResult|
	aResult:=(BitmapStreamTests selector: #testShortIntegerArrayWithImageSegment) classUnderTest.
	self assert: (aResult = FileStream).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 12/29/2003 15:19'!
testSelectorUnderTest2
	|aResult|
	aResult:=(TestCaseTest selector: #testSum) selectorUnderTest.
	self assert: (aResult = #sum).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/6/2004 01:08'!
testSum
	|aResult|
	aResult:= (1 to: 10) sum.
	self assert: (aResult = 55).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:43'!
testReceiverUnderTest2
	|aResult|
	aResult:=(self class selector: #testNewChar) receiverUnderTest.
	self assert: (aResult= Character).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/6/2004 01:08'!
testSelectorUnderTest
	|aResult|
	aResult:=(TestCaseTest selector: #testSelectorUnderTest) selectorUnderTest.
	self assert: (aResult = #selectorUnderTest).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/4/2004 21:11'!
testCompiledMethodUnderTest2
	|aResult|
	aResult:=(TestCaseTest selector: #testSum) compiledMethodUnderTest.
	self assert: (aResult = (Collection lookupSelector: #sum)).
	^aResult! !

!TestCaseTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:43'!
testReceiverUnderTest3
	|aResult|
	aResult:=(self class selector: #testBitmapByteAt) receiverUnderTest.
	self assert: (aResult class= Bitmap).
	^aResult! !

!TestCase methodsFor: '*Eg-TestExperiments' stamp: 'mga 1/5/2004 22:29'!
receiverContainingTestSelector
	|aTree lastAssignment | 
	aTree:= (self class methodDictionary at: testSelector) parseTree.
	self assert: (aTree body lastIsReturn).
	lastAssignment := aTree methodUnderTestAssignment.
	((lastAssignment value isKindOf: RBVariableNode) or: [lastAssignment value receiver name ~= 'self']) ifTrue: [^testSelector].
	^lastAssignment value selfMessages asOrderedCollection first! !

!TestCase methodsFor: '*Eg-TestExperiments' stamp: 'mga 1/5/2004 12:12'!
methodReferenceUnderTest
	|aCompMethod|   
	aCompMethod:=self compiledMethodUnderTest.
	^MethodReference class: aCompMethod methodClass selector: aCompMethod selector! !

!TestCase methodsFor: '*Eg-TestExperiments' stamp: 'mga 1/5/2004 22:28'!
selectorUnderTest
	|aTree lastAssignment | 
	aTree:= (self class methodDictionary at: self receiverContainingTestSelector) parseTree.
	self assert: (aTree body lastIsReturn).
	lastAssignment := aTree methodUnderTestAssignment.
	^lastAssignment value selector! !

TestCase subclass: #BalloonFontTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests'!

!BalloonFontTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
testDefaultFont
	"(self selector: #testDefaultFont) debug"
	"(self selector: #testDefaultFont) selectorUnderTest"
	|aResult|
	aResult:= RectangleMorph new defaultBalloonFont.
	self assert: RectangleMorph new balloonFont = BalloonMorph balloonFont.
	self assert: aResult = BalloonMorph balloonFont.
	^aResult! !

!BalloonFontTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:45'!
testSpecificFont
	"(self selector: #testSpecificFont) debug"
	"(self selector: #testSpecificFont) selectorUnderTest"
	
	| aMorph aResult|
	aMorph := RectangleMorph new.
	self assert: RectangleMorph new balloonFont = BalloonMorph balloonFont.
	self assert: RectangleMorph new defaultBalloonFont = BalloonMorph balloonFont.
	aResult:= aMorph
		balloonFont: (StrikeFont familyName: #ComicPlain size: 19).
	self assert: aMorph balloonFont
			= (StrikeFont familyName: #ComicPlain size: 19).
	"The next test is horrible because I do no know how to access the font 
	with the appropiate interface"
	self assert: (((BalloonMorph getTextMorph: 'lulu' for: aMorph) text runs at: 1)
			at: 1) font
			= (StrikeFont familyName: #ComicPlain size: 19).
	^aResult! !

TestCase subclass: #BlockContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests-Tests-Kernel-Methods'!

!BlockContextTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testValueWithArguments
	|aResult|
	self
		should: [[3 + 4]
				valueWithArguments: #(1 )]
		raise: Error.
	self
		shouldnt: [aResult:=[3 + 4]
				valueWithArguments: #()]
		raise: Error.
	[[3 + 4]
		valueWithArguments: #(1 )]
		ifError: [:err :rcvr | self assert: err = 'Error: This block accepts 0 arguments, but was called with 1.'].
	[[:i | 3 + 4]
		valueWithArguments: #(1 2)]
		ifError: [:err :rcvr | self assert: err = 'Error: This block accepts 1 argument, but was called with 2.'].
	^aResult! !

!BlockContextTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testOneArgument
	| c aResult |
	c _ OrderedCollection new.
	c add: 'hello'.
	aResult:=[c
		do: [1 + 2]]
		ifError: [:err :rcvr | self deny: err = 'This block requires 0 arguments.'].
	[c
		do: [:arg1 :arg2 | 1 + 2]]
		ifError: [:err :rcvr | self deny: err = 'This block requires 2 arguments.'].
	^aResult! !

!BlockContextTest methodsFor: 'testing' stamp: 'mga 1/5/2004 22:46'!
testNoArguments
	|aResult|
	aResult:=[10
		timesRepeat: [:arg | 1 + 2]]
		ifError: [:err :rcvr | self deny: err = 'This block requires 1 arguments.'].
	[10
		timesRepeat: [:arg1 :arg2 | 1 + 2]]
		ifError: [:err :rcvr | self deny: err = 'This block requires 2 arguments.'].
	^aResult ! !

ExtractToTemporaryRefactoring subclass: #ExtractToResultRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments'!

!ExtractToResultRefactoring methodsFor: 'as yet unclassified' stamp: 'mga 1/25/2004 17:29'!
insertTemporary
	| node statementNode |
	node := self parseTree whichNodeIsContainedBy: sourceInterval.
	(node notNil and: [node isValue]) 
		ifFalse: [self refactoringError: 'Cannot assign to non-value nodes'].
	statementNode := node statementNode.
	node replaceWith: (RBVariableNode named: newVariableName).
	(statementNode parent)
		addNode: (self constructAssignmentFrom: node)
			before: (node == statementNode 
					ifTrue: [RBVariableNode named: newVariableName]
					ifFalse: [statementNode]).
	parseTree body addTemporaryNamed: newVariableName! !

!ExtractToResultRefactoring methodsFor: 'as yet unclassified' stamp: 'mga 1/25/2004 17:06'!
transform
	self
		insertTemporary;
		insertResult;
		compileNewMethod! !

!ExtractToResultRefactoring methodsFor: 'as yet unclassified' stamp: 'mga 1/25/2004 17:16'!
insertResult
	| node |
	parseTree lastIsReturn ifTrue: [^self halt].
	node := RBReturnNode value: (RBVariableNode named: newVariableName).
	parseTree addNode: node! !

Object subclass: #NameOfSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Eg-TestExperiments-ConvertedTests-Tests-Bugs'!
